#ifdef _WIN32
#define COPT_CALL __stdcall
#else
#define COPT_CALL
#endif

#define COPTCPP_API extern "C"

#include "logcallback.h"
#include "coptcpp.idl.h"

COPTCPP_API
Copt::IVarArray* COPT_CALL CreateVarArray();

COPTCPP_API
Copt::IConstrArray* COPT_CALL CreateConstrArray();

COPTCPP_API
Copt::IColumn* COPT_CALL CreateColumn();

COPTCPP_API
Copt::IColumnArray* COPT_CALL CreateColumnArray();

COPTCPP_API
Copt::IExpr* COPT_CALL CreateExpr(double constant);

COPTCPP_API
Copt::IExpr* COPT_CALL CreateLinExpr(Copt::IVar* var, double coeff);

COPTCPP_API
Copt::IQuadExpr* COPT_CALL CreateQuadExpr1(double constant);

COPTCPP_API
Copt::IQuadExpr* COPT_CALL CreateQuadExpr2(Copt::IVar* var, double coeff);

COPTCPP_API
Copt::IQuadExpr* COPT_CALL CreateQuadExpr3(Copt::IExpr* expr);

COPTCPP_API
Copt::IQuadExpr* COPT_CALL CreateQuadExpr4(Copt::IExpr* expr, Copt::IVar* var);

COPTCPP_API
Copt::IQuadExpr* COPT_CALL CreateQuadExpr5(Copt::IExpr* left, Copt::IExpr* right);

COPTCPP_API
Copt::IPsdExpr* COPT_CALL CreatePsdExpr1(double constant);

COPTCPP_API
Copt::IPsdExpr* COPT_CALL CreatePsdExpr2(Copt::IVar* var, double coeff);

COPTCPP_API
Copt::IPsdExpr* COPT_CALL CreatePsdExpr3(Copt::IExpr* expr);

COPTCPP_API
Copt::IPsdExpr* COPT_CALL CreatePsdExpr4(Copt::IPsdVar* var, Copt::ISymMatrix* mat);

COPTCPP_API
Copt::IPsdExpr* COPT_CALL CreatePsdExpr5(Copt::IPsdVar* var, Copt::ISymMatExpr* expr);

COPTCPP_API
Copt::ILmiExpr* COPT_CALL CreateLmiExpr1();

COPTCPP_API
Copt::ILmiExpr* COPT_CALL CreateLmiExpr2(Copt::ISymMatrix* mat);

COPTCPP_API
Copt::ILmiExpr* COPT_CALL CreateLmiExpr3(Copt::ISymMatExpr* expr);

COPTCPP_API
Copt::ILmiExpr* COPT_CALL CreateLmiExpr4(Copt::IVar* var, Copt::ISymMatrix* mat);

COPTCPP_API
Copt::ILmiExpr* COPT_CALL CreateLmiExpr5(Copt::IVar* var, Copt::ISymMatExpr* expr);

COPTCPP_API
Copt::IConstrBuilder* COPT_CALL CreateConstrBuilder();

COPTCPP_API
Copt::IConstrBuilderArray* COPT_CALL CreateConstrBuilderArray();

COPTCPP_API
Copt::ISosArray* COPT_CALL CreateSosArray();

COPTCPP_API
Copt::ISosBuilder* COPT_CALL CreateSosBuilder();

COPTCPP_API
Copt::ISosBuilderArray* COPT_CALL CreateSosBuilderArray();

COPTCPP_API
Copt::IGenConstrArray* COPT_CALL CreateGenConstrArray();

COPTCPP_API
Copt::IGenConstrBuilder* COPT_CALL CreateGenConstrBuilder();

COPTCPP_API
Copt::IGenConstrBuilderArray* COPT_CALL CreateGenConstrBuilderArray();

COPTCPP_API
Copt::IConeArray* COPT_CALL CreateConeArray();

COPTCPP_API
Copt::IConeBuilder* COPT_CALL CreateConeBuilder();

COPTCPP_API
Copt::IConeBuilderArray* COPT_CALL CreateConeBuilderArray();

COPTCPP_API
Copt::IQConstrArray* COPT_CALL CreateQConstrArray();

COPTCPP_API
Copt::IQConstrBuilder* COPT_CALL CreateQConstrBuilder();

COPTCPP_API
Copt::IQConstrBuilderArray* COPT_CALL CreateQConstrBuilderArray();

COPTCPP_API
Copt::IPsdVarArray* COPT_CALL CreatePsdVarArray();

COPTCPP_API
Copt::IPsdConstrArray* COPT_CALL CreatePsdConstrArray();

COPTCPP_API
Copt::IPsdConstrBuilder* COPT_CALL CreatePsdConstrBuilder();

COPTCPP_API
Copt::IPsdConstrBuilderArray* COPT_CALL CreatePsdConstrBuilderArray();

COPTCPP_API
Copt::ILmiConstrArray* COPT_CALL CreateLmiConstrArray();

COPTCPP_API
Copt::ISymMatrixArray* COPT_CALL CreateSymMatrixArray();

COPTCPP_API
Copt::ISymMatExpr* COPT_CALL CreateSymMatExpr1();

COPTCPP_API
Copt::ISymMatExpr* COPT_CALL CreateSymMatExpr2(Copt::ISymMatrix* mat, double coeff);

COPTCPP_API
Copt::IModel* COPT_CALL CreateModel(Copt::IEnvr* env, const char* szName);

COPTCPP_API
Copt::IEnvr* COPT_CALL CreateEnvr(ILogCallback* pcb);

COPTCPP_API
Copt::IEnvr* COPT_CALL CreateEnvrWithPath(const char* szLicDir, ILogCallback* pcb);

COPTCPP_API
Copt::IEnvr* COPT_CALL CreateEnvrWithConfig(Copt::IEnvrConfig* config, ILogCallback* pcb);

COPTCPP_API
Copt::IEnvrConfig* COPT_CALL CreateEnvrConfig();

COPTCPP_API
Copt::IProbBuffer* COPT_CALL CreateProbBuffer(int sz);

COPTCPP_API
Copt::ICallbackProxy* COPT_CALL CreateCallbackProxy();

COPTCPP_API
int COPT_CALL GetCoptVersion(int type);
